
        org  63000

SCR_CT: equ  23692           ;scroll counter
XBEG:   equ  27100           ;bit index start
HBEG:   equ  XBEG+1252       ;history start
IBEG:   equ  34000           ;input start
MAXLEN: equ  15              ;maximum match length
MCWORK: equ  65400           ;start of working storage

PTMP:   equ  MCWORK          ;00 window match start address (temporary)
PBEG:   equ  MCWORK+2        ;02 window match start address (final)
PLEN:   equ  PBEG+2          ;04 window match length
OBYTES: equ  PLEN+2          ;06 encoded bytes output
CPOS:   equ  OBYTES+2        ;08 coding position
CNXT:   equ  CPOS+2          ;10 lookahead pointer
LEND:   equ  CNXT+2          ;12 encoding end
LPOS:   equ  LEND+2          ;14 encoding step; starts at IEND
BBEG:   equ  LPOS+4          ;18 encoded bytes start  (IEND)
WINDIFF:equ  LPOS+6          ;20 (WINZ-PINA+1)-(WWIDTH) flag: 0=equal, else=not equal
PWIDTHF:equ  LPOS+7          ;21 window width (adjusted) flag: 0=zero, else=not zero
WINA:   equ  LPOS+8          ;22 LH window boundary
WINZ:   equ  WINA+2          ;24 RH window boundary
PINA:   equ  WINZ+2          ;26 LH window boundary (adjusted)
WWIDTH: equ  PINA+2          ;28 window width (pict=2047, text=4095)
DBEG:   equ  PINA+6          ;32 decoded output start (LEND)

LVALUE: equ  MCWORK+34       ;start of l() array values
CLEN:   equ  LVALUE+2        ;entry match length
STATSON:equ  CLEN+2          ;NOP=off,CALL=on

TXTSCR: equ  MCWORK+40       ;*entered: 1=text, 0=pict
TXTPRT: equ  MCWORK+41       ;*entered: 1=print, 0=don't
ILEN:   equ  MCWORK+42       ;*entered: input length (2048-10000)
IEND:   equ  MCWORK+44       ;=calculated: input end (IBEG+ILEN)
ILAST:  equ  MCWORK+46       ;=calculated: input last byte address (IEND-1)
XCOUNT: equ  MCWORK+50       ;bit index counter (=$00 if not used)
XBIT:   equ  MCWORK+51       ;set if data entry has associated bit index entry
SETOFF: equ  MCWORK+52       ;search offset: 0 or 1
SETLEN: equ  MCWORK+53       ;search result for offset 0
SAVEIX: equ  MCWORK+54
BUFFER: equ  MCWORK+60       ;workspace

PRINTI: equ  $1a1b           ;OUT-NUM-1 print a small integer BC
PRINTS: equ  $203c           ;PR-STRING print a string length BC from DE
PRINTFP:equ  $2de3           ;PRINT-FP  print number on calculator stack
STORES: equ  $2ab6           ;to calculator stack: AEDCB
FETCHS: equ  $2bf1           ;from calculator stack: AEDCB
STAKA:  equ  $2d28           ;to calculator stack: A
STAKBC: equ  $2d2b           ;to calculator stack: BC
FPTOBC: equ  $2da2           ;from calculator stack: BC
FPTOA:  equ  $2dd5           ;from calculator stack: A

;TEXT ENCODING ($00-$7F) - no bit index entry
; 0 matches: 1 byte  : 0fffgggg
; 1 match:   2 bytes : 0bbbbbbb 0fffgggg
;2+ matches: bit index 1  + 3 bytes : 1llllooo oooooooo offfgggg : len+offhi+offlo+chr
;DATA ENCODING ($80-$FF) -  1 bit index entry
; 0 matches: bit index 0  + 1 byte  : 1fffgggg
; 1 match:   bit index 00 + 2 bytes : 1bbbbbbb ?fffgggg
;2+ matches: bit index 1  + 3 bytes : 1llllooo oooooooo ffffgggg : len+offhi+offlo+chr

PROGLEN:defw PROGEND-OUTPUT+3

        ;output subroutine
OUTPUT: ld   hl,BUFFER
        ld   a,(PLEN)
        cp   1
        jp   z,MATCH1        ;IF PLEN=1
        jp   c,MATCH0        ;IF PLEN=0

;2+ matches: bit index 1  + 3 bytes : 1llllooo oooooooo ffffgggg
MATCH2: ex   af,af'
        exx
        ld   hl,(CNXT)
        ld   a,(hl)          ;A =ffffgggg
        ld   bc,(PBEG)
        sbc  hl,bc
        ld   bc,(PLEN)       ;deduct (CNXT-CPOS)
        sbc  hl,bc           ;HL=lookback offset
        push hl
        exx

        ;               A        B        C        D
        ;change 4 bytes 0000llll|00000<o>|[oooooo]|ffffgggg
        ;    to 3 bytes 1llll<o> [oooooo] ffffgggg (pict)
        ;    or         0000llll|0000<oo>|[oooooo]|0fffgggg
        ;    to         1llll<oo >[oooooo ]fffgggg (text)
        pop  bc              ;BC=lookback offset
        ld   d,a             ;D =character at (CNXT)

        ld   a,(XCOUNT)
        or   a
        jp   nz,PICTXT1      ;jump if pict
        srl  b               ;B =00000<oo >
        rr   c               ;C =>[oooooo ]
        rr   a               ;A =]0000000
        add  a,d             ;A =]fffgggg
        ld   d,a

PICTXT1:ex   af,af'          ;A =(PLEN)
        sla  a
        sla  a
        sla  a               ;A =0llll000
        or   %10000000       ;A =1llll000
        add  a,b

        ld   (hl),a          ;A =1llllooo type 1 flag + PLEN
        inc  hl
        ld   (hl),c          ;C =oooooooo offset
        inc  hl
        ld   (hl),d          ;D =?fffgggg =character
        ld   a,(XCOUNT)
        or   (ix+00)
        ld   (ix+00),a
        call COUNTX
        ld   hl,BUFFER
        ld   de,(LPOS)
        ldi
        ldi
        ldi
        ld   (LPOS),de
        ld   e,3             ;E =byte copy counter
        jp   OUTEND

COUNTX: ld   a,(XCOUNT)
        srl  a
        jp   nc,NOINCX
        inc  ix              ;increment bit index pointer
        rra
NOINCX: ld   (XCOUNT),a
        ret

; 1 match:   2 bytes : 0bbbbbbb 0bbbbbbb
; 1 match:   bit index 00 + 2 bytes : 1bbbbbbb 1bbbbbbb
MATCH1: ld   de,(PBEG)
        ld   a,(de)
        ld   (hl),a
        inc  hl
        and  %10000000
        call nz,COUNTX
        ld   de,(CNXT)
        ld   a,(de)
        ld   (hl),a
        and  %10000000
        call nz,COUNTX
        ld   hl,BUFFER
        ld   de,(LPOS)
        ldi
        ldi
        ld   (LPOS),de
        ld   e,2             ;E =byte copy counter
        jp   OUTEND

; 0 matches: 1 byte  : 0bbbbbbb
; 0 matches: bit index 0  + 1 byte  : 1bbbbbbb
MATCH0: ld   de,(CNXT)
        ld   a,(de)
        ld   (hl),a
        and  %10000000
        call nz,COUNTX
        ld   hl,BUFFER
        ld   de,(LPOS)
        ldi
        ld   (LPOS),de
        ld   e,1             ;E =byte copy counter

OUTEND: ld   hl,(OBYTES)
        ld   d,0
        add  hl,de           ;add DE bytes
        ld   (OBYTES),hl

        ;update history for characters just encoded
        ld   hl,(CPOS)
        ld   bc,HBEG
        exx
        ld   a,(PLEN)
        ld   b,a
        inc  b
HISTSET:exx
        ld   e,(hl)
        xor  a               ;#
        sla  e               ;#
        rla                  ;#
        ld   d,a             ;#DE=character code * 2
        ex   de,hl           ;#DE=input   address for character
        add  hl,bc           ;#HL=history address for character
        ld   (hl),e          ;#
        inc  hl              ;#
        ld   (hl),d          ;#
        ex   de,hl
        inc  hl
        exx
        djnz HISTSET
        exx

        ld   de,(PLEN)       ;update pointers by PLEN+1
        inc  de
        ld   hl,(WINA)
        add  hl,de
        ld   (WINA),hl
        ld   hl,(PINA)
        add  hl,de
        ld   (PINA),hl
        ld   hl,(WINZ)
        add  hl,de
        ld   (WINZ),hl
        ld   hl,(CPOS)
        add  hl,de
        ld   (CPOS),hl
        ret

        ;ENCODING SETUP
SETUPE: ld   hl,IBEG         ;IBEG=input start
        ld   bc,(ILEN)       ;ILEN=input length
        ld   de,2046
CHECK7F:ld   a,(hl)
        and  %10000000       ;check for chars > $7F
        jr   nz,USEBITX
        inc  hl
        dec  bc
        ld   a,b
        or   c
        jr   nz,CHECK7F
        ld   de,4094
USEBITX:ld   (XCOUNT),a      ;=$00 if text-only; =$80 if not
        ld   ix,XBEG+2       ;start of bit index
        ld   (WWIDTH),de

        ld   hl,IBEG
        ld   (CPOS),hl       ;(CPOS)=coding position
        ld   bc,(ILEN)
        add  hl,bc
        ld   (IEND),hl       ;(IEND)=input end
        ld   (LPOS),hl       ;(LPOS)=encoded output start
        dec  hl
        ld   (ILAST),hl
        ld   de,0
        ld   (OBYTES),de     ;(OBYTES)=encoded bytes output
        ld   (SETOFF),de     ;(SETOFF)+(SETLEN) reset
        ld   (PLEN),de

        ld   hl,IBEG
        ld   bc,(WWIDTH)     ;(WWIDTH)=window width
        sbc  hl,bc           ;HL=IBEG-(WWIDTH)
        ld   (WINA),hl       ;WINA,WINZ=left,right window boundaries
        ld   hl,IBEG
        dec  hl
        ld   (WINZ),hl

        exx
        push hl              ;save H'L' (holds calculator RET address)
        exx

        xor  a
        ld   (PWIDTHF),a
        ld   hl,XBEG         ;#
        ld   (hl),a          ;#
        ld   de,XBEG+1       ;#
        ld   bc,512+1252-1   ;#
        ldir                 ;#clear index & history tables
        ld   hl,IBEG

        ;START OF THE ENCODING LOOP
ENLOOP: ld   hl,(WINA)       ;#3
        ld   de,IBEG
        xor  a
        ld   bc,(WINA)
        sbc  hl,de
        jr   nc,LET_PA       ;IF WINA>=IBEG
        ld   bc,IBEG         ;IF WINA< IBEG
        dec  a

LET_PA: ld   (PINA),bc       ;PINA=adjusted LH window boundary
        ld   (WINDIFF),a
        ld   hl,(WINZ)
        and  a
        sbc  hl,bc
        inc  hl
        ld   b,h
        ld   c,l             ;BC=adjusted window width

        ;loop return point if window is fully open
        ;BC holds counter for CPDR
ENLOOPZ:ld   hl,(CPOS)
        ld   de,(IEND)
        sbc  hl,de
        jp   nc,EOINPUT       ;end of input

        ld   de,(CPOS)
        ld   (CNXT),de       ;lookahead pointer
        ld   de,0
        ld   (PBEG),de
        ld   a,e
        ld   (PLEN),a        ;PBEG,PLEN = matched start,length in window
        ld   hl,(WINZ)

        ld   a,(PWIDTHF)
        or   a
        jp   nz,HISTORY      ;#
        inc  a               ;only done once
        ld   (PWIDTHF),a
        jp   LONGEST

HISTORY:exx                  ;check for initial match in history table
        ld   hl,(CPOS)
        ld   c,(hl)          ;C =character at Coding Position
        xor  a
        sla  c
        rla
        ld   b,a             ;BC=character code * 2
        ld   hl,HBEG
        add  hl,bc           ;HL=history address for character
        ld   e,(hl)
        inc  hl
        ld   d,(hl)
        push de
        ex   de,hl           ;HL=old character position
        ld   bc,(PINA)       ;BC=LH window boundary (adjusted)
        sbc  hl,bc
        exx
        pop  de
        jp   c,LONGEST       ;most recent match < LH window boundary

        sbc  hl,de           ;HL=displacement
        push de              ;DE=old character position (new pointer)
        ex   de,hl           ;DE=displacement
        ld   h,b
        ld   l,c
        sbc  hl,de           ;adjust CPDR counter
        ld   b,h
        ld   c,l
        pop  hl
        ld   de,(CPOS)
        jp   MASTART

PA2PZ:  ld   a,(de)          ;A =character at Coding Position
        cpdr                 ;search backwards for another match
        jp   nz,LONGEST      ;no further match
        inc  hl

        inc  hl              ;match on 1st chars
        inc  de              ;check on 2nd chars
        ld   a,(de)
        cp   (hl)
        dec  de
        dec  hl
        jp   nz,NOTNEXT      ;no 2nd match

MASTART:push hl           ;1>
        exx                  ;H'L' was saved prior to entering ENLOOP
        pop  hl           ;1<
        ld   bc,0            ;match length
        ld   de,(CPOS)
        jp   MANEXT1         ;first match already done

        ;determine the extent of the match
MALOOP: ld   a,(de)          ;compare lookahead character
        cp   (hl)            ;   with window character
        jp   nz,NEXTSW       ;no further match

MANEXT1:ld   a,(CPOS)
        cp   l
        jp   nz,MANEXT2
        ld   a,(CPOS+1)
        cp   h
        jp   z,NEXTSW        ;reached Coding Position

MANEXT2:ld   a,(ILAST)
        cp   e
        jp   nz,MANEXT3
        ld   a,(ILAST+1)
        cp   d
        jp   z,NEXTSW        ;reached end of input

MANEXT3:inc  c
        inc  hl              ;window pointer
        inc  de              ;lookahead pointer
        ld   a,c             ;A =new match length
        cp   MAXLEN
        jp   nz,MALOOP

NEXTSW: ld   a,(PLEN)        ;A =longest match length so far
        cp   c
        ld   a,c             ;A =new match length
        jp   nc,NOTLONG

        ld   (CNXT),de
        and  a
        sbc  hl,bc           ;HL=window pointer - match length
        ld   (PBEG),hl       ;  =match start address
        ld   (PLEN),a

NOTLONG:exx
        cp   MAXLEN
        jp   nc,LONGEST
NOTNEXT:dec  hl
        ld   a,b
        or   c
        jp   nz,PA2PZ        ;check remainder of window

        ;no further matches in window; output the last longest match (if any)
        ;(PBEG) & (PLEN) will identify the last longest match found
LONGEST:ld   a,(XCOUNT)
        or   a
        ld   a,1
        jp   nz,PICFILE
        inc  a
PICFILE:ld   bc,(PLEN)
        cp   c               ;A =1 pict, =2 text
        jp   c,NOTLENC
        xor  a
        ld   (PLEN),a        ;ignore up to C-char matches
        ld   hl,(CNXT)
        sbc  hl,bc
        ld   (CNXT),hl
NOTLENC:
        ld   a,(SETOFF)
        or   a
        jp   nz,SETOFF1

        inc  a
        ld   (SETOFF),a      ;set toggle
        ld   a,(PLEN)
        ld   (SETLEN),a      ;save matched length
        ld   hl,MCWORK
        ld   de,MCWORK+76
        ld   bc,52
        ldir                 ;save workspace
        ld   (SAVEIX),ix     ;and IX
        ld   b,0
        ld   c,a
        xor  a
        ld   (PLEN),a        ;reset (PLEN)
        ld   hl,(CNXT)
        sbc  hl,bc           ;HL=(CNXT)-(PLEN)
        ld   (CNXT),hl
        jp   SETOUT          ;just copy one byte

SETOFF1:dec  a
        ld   (SETOFF),a      ;reset toggle
        ld   a,(PLEN)
        ld   c,a             ;C =current  matched length
        ld   a,(SETLEN)      ;A =previous matched length
        cp   c
        jp   c,SETOUT        ;if current matched > previous, encode current
        ld   de,MCWORK
        ld   hl,MCWORK+76
        ld   bc,52
        ldir                 ;restore previous workspace
        ld   ix,(SAVEIX)     ;and ix and encode previous (PLEN)+1

SETOUT: call OUTPUT
        ld   a,(WINDIFF)
        or   a               ;window fully open?
        jp   nz,ENLOOP       ;no
        ld   bc,(WWIDTH)
        jp   ENLOOPZ

EOINPUT:and a
        push ix              ;IX=bit index byte counter
        pop  hl
        ld   bc,XBEG+2
        sbc  hl,bc           ;HL=bit index full bytes
        sla  l
        rl   h
        sla  l
        rl   h
        sla  l
        rl   h               ;HL*8=bits in full bytes of bit index
        ld   de,0
        ld   a,(XCOUNT)
        or   a
        jr   z,NCOUNT
SCOUNT: inc  e
        sla  a               ;10000000=0, 01000000=1, 00100000=2, etc.
        jr   nc,SCOUNT
        dec  e
NCOUNT: add  hl,de           ;HL=total bits in bit index
        ld   (XBEG),hl       ;store total at start of bit index

        ;DECODING SETUP
SETUPD: call $0d6b           ;CLS
        ld   a,$FE
        call $1601           ;CHAN_OPEN
        call STATS           ;find l() array
        ld   de,(LPOS)
        ld   (LEND),de
        ld   a,(TXTPRT)      ;1=print, 0=don't
        or   a
        jr   z,SETDBEG
        ld   a,(TXTSCR)      ;1=text, 0=pict
        or   a
        jr   nz,SETDBEG
        ld   de,16384
SETDBEG:ld   (DBEG),de       ;DE=decoded output start
        ld   hl,(IEND)
        ld   (LPOS),hl       ;HL=encoded output start

        ld   bc,(OBYTES)     ;BC=total encoded bytes (excluding bit index)
        ld   ix,XBEG+2       ;start of bit index
        ld   a,(XCOUNT)
        or   a
        jr   z,S1TOLP        ;bit index not used (text-only)
        ld   a,%10000000
        ld   (XCOUNT),a

        ;START OF THE DECODING LOOP
S1TOLP: push bc           ;0>;BC=loop counter
        push hl           ;1>;HL=encoding pointer
        push de           ;2>;DE=decoding pointer
        ld   (PTMP),de

        ld   b,(hl)
        inc  hl
        ld   c,(hl)
        inc  hl
        ld   d,(hl)

        xor  a
        ld   (XBIT),a
        bit  7,b             ;check data type of entry
        jp   z,JUSTL         ;text 1 byte
        ld   a,(XCOUNT)
        or   a
        jr   z,COPYOFF       ;text-only 3 bytes
        and  (ix+00)
        ex   af,af'          ;save flags
        call COUNTX
        ex   af,af'
        ld   a,1
        ld   (XBIT),a
        jp   nz,COPYOFF      ;text/data 3 bytes

JUSTL:  ld   d,c             ;text/data 1 byte
        ld   c,b             ;just move down character bytes
        ld   b,0             ;to make room for match length

        push hl
        exx
        pop  hl
        ld   bc,(LEND)
        sbc  hl,bc
        exx
        jp   nc,KEEPOFF      ;at end of encoding

        bit  7,d             ;check for an adjacent 1-byte entry
        jp   z,MATCHED       ;next OK, type 0 1-byte entry
        ld   a,(XCOUNT)      ;next is a type 1 entry, check length
        or   a
        jp   z,KEEPOFF       ;text-only 3 bytes
        and  (ix+00)
        jp   nz,KEEPOFF      ;next not OK, type 1 3-byte entry
        call COUNTX
        ld   a,(XBIT)
        inc  a
        ld   (XBIT),a
MATCHED:inc  b
        jp   KEEPOFF

        ;               B        C        D        E
        ;change 3 bytes 1llllooo oooooooo ffffgggg
        ;    to 4 bytes 0000llll|00000ooo|oooooooo|ffffgggg
        ;or
        ;change 3 bytes 1llllooo oooooooo offfgggg
        ;    to 4 bytes 0000llll|0000oooo|oooooooo|0fffgggg
COPYOFF:ld   e,d
        ld   d,c             ;B =1llllooo C=oooooooo D=oooooooo E=offfgggg
        ld   a,b             ;A =1llllooo
PICTXT3:and  %00000111       ;A =00000ooo
        ld   c,a             ;B =1llllooo C=00000ooo D=oooooooo E=offfgggg
        ld   a,b             ;A =1llllooo
        and  %01111000       ;A =0llll000
        srl  a
        srl  a
        srl  a               ;A =00001111
        ld   b,a             ;B =00001111 C=00000ooo D=oooooooo E=offfgggg

        ld   a,(XCOUNT)
        or   a
        jp   nz,KEEPOFF      ;jump if pict
        sla  e               ;E =fffgggg0 o
        rl   d               ;D =oooooooo o
        rl   c               ;C =0000oooo 0
        srl  e               ;E =0fffgggg 0

KEEPOFF:ld   a,b             ;A =PLEN
        push af           ;3>
        cp   1
        jp   z,DECODE1       ;IF PLEN=1
        jp   c,DECODE0       ;IF PLEN=0

        ;               B        C        D        E
        ;    to 4 bytes 0000llll|.....ooo|oooooooo|ffffgggg
        ;or
        ;    to 4 bytes 0000llll|....oooo|oooooooo|0fffgggg
DECODE2:push de           ; >;save next character: ?fffgggg
        ld   l,d
        ld   h,c             ;HL=match offset
        ld   de,(PTMP)       ;DE=decoding pointer
        ex   de,hl
        sbc  hl,de           ;HL=copy point  from decoded output
        ld   c,a
        ld   b,0             ;BC=copy length from decoded output
        push bc           ;4>
        ld   de,BUFFER       ;DE=copy point to print buffer
        ldir
        pop  bc           ;4<
        inc  bc
        pop  hl           ; <
        ld   a,l             ;A =next char after matched string
        ld   (de),a
        jp   PRINTDE

DECODE1:ld   h,d
        ld   de,BUFFER
        ld   a,c
        ld   (de),a
        inc  de
        ld   a,h
        ld   (de),a
        ld   bc,2
        jp   PRINTDE

DECODE0:ld   de,BUFFER
        ld   a,c
        ld   (de),a
        ld   bc,1

PRINTDE:ld   de,BUFFER
        push bc           ;4>
        ld   a,(TXTSCR)      ;1=text, 0=pict
        or   a
        jp   z,NOPRINT
        ld   a,(TXTPRT)      ;1=print, 0=don't
        or   a
        jp   z,NOPRINT
        call PRINTS
NOPRINT:pop  bc           ;4<
        pop  af           ;3<;A =PLEN
STATPOS:call STATLEN
        ld   hl,BUFFER
        pop  de           ;2<
        ldir

        pop  hl           ;1<;HL=current LPOS
        pop  bc           ;0<
        cp   1
        jp   z,TWOBYTE       ;IF PLEN=1
        jp   c,ONEBYTE       ;IF PLEN=0
        inc  hl
        dec  bc
TWOBYTE:inc  hl
        dec  bc
ONEBYTE:inc  hl
        dec  bc
        ld   a,b
        or   c
        jp   nz,S1TOLP

        ;END OF THE DECODING LOOP
        exx
        pop hl               ;restore H'L'
        exx

        ld   de,PRIN
        ld   bc,5
        call PRINTS
        ld   bc,(ILEN)
        call PRINTBC

        ld   de,PROUT
        ld   bc,5
        call PRINTS

        ld   bc,(OBYTES)
        call STAKBC
        ld   bc,(XBEG)
        call STAKBC
        ld   a,8
        call STAKA
        rst  $28
        defb $05   ;divide   ;(XBEG)/8 = bit index bytes
        defb $0F   ;add      ;(XBEG)/8 + (OBYTES) = total bytes output
        defb $31   ;duplicate
        defb $38   ;end_calc
        call PRINTFP

        ld   de,PRAT
        ld   bc,4
        call PRINTS
        ld   bc,(IEND)
        ld   (BBEG),bc
        call PRINTBC

        ld   de,PRDIFF
        ld   bc,6
        call PRINTS
        ld   bc,(ILEN)
        call STAKBC          ;b,l
        rst  $28
        defb $C5   ;store_M5
        defb $03   ;subtract ;b-l
        defb $E5   ;recall_M5;b-l,l
        defb $A4   ;const_ten;b-l,l,10
        defb $A4   ;const_ten;b-l,l,10,10
        defb $04   ;multiply ;b-l,l,100
        defb $01   ;exchange ;b-l,100,l
        defb $05   ;divide   ;b-l,100/l
        defb $04   ;multiply ;(b-l)*100/l
        defb $27   ;int      ;INT ((b-l)*100/l)=diff
        defb $31   ;duplicate;diff,diff
        defb $29   ;sgn      ;diff,SGN diff
        defb $38   ;end_calc
        call FPTOA
        jr   nz,NEGDIF
        ld   a,"+"
        rst  $10
NEGDIF: call PRINTFP         ;diff
        ld   a,"%"
        rst  $10
        ld   a,$0d
        rst  $10
        ret

PRINTBC:call STAKBC
        call PRINTFP
        ret

PRIN:   defb $0d,$0d
        defm "In"
        defb $06
PROUT:  defb $0d
        defm "Out"
        defb $06
PRAT:   defb $0d
        defm "at"
        defb $06
PRDIFF: defb $0d
        defm "Diff"
        defb $06


;===================


CH_ADD: equ  23645
LARRAY: defm "l():"

STATS:  ld   bc,(CH_ADD)
        push bc           ;1>
        ld   bc,LARRAY
        ld   (CH_ADD),bc
        call $28b2           ;LOOK-VARS
        pop  bc           ;1<
        ld   (CH_ADD),bc
        jp   c,$1c2e         ;"2 - Variable not found"
        ld   bc,8
        add  hl,bc
        ld   (LVALUE),hl

        ld   a,(STATSON)
        ld   (STATPOS),a
        ld   (STATPOS+1),a
        ld   (STATPOS+2),a   ;disable statistics
        or   a
        ret  z
        ld   hl,STATLEN
        ld   (STATPOS+1),hl  ;enable statistics
        ret

STATLEN:push de
        push bc
        push af

        ld   (CLEN),a        ;A =entry match length (0-15)
        ld   c,a
        sla  a
        sla  a
        sla  a
        sla  a
        sub  c
        ld   b,0
        ld   c,a             ;BC=l(len) row offset
        ld   hl,(LVALUE)
        add  hl,bc           ;HL=l(len) row address

        call LDAEDCB         ;get l(len,1)
        push hl           ;1>;HL=l(len,2) address
        ld   e,1
        call ADDINT
        call LDAEDCB         ;get l(len,2)
        push hl
        call STORES          ;stack l(len,2)
        pop  hl
        call LDAEDCB         ;get l(len,3)
        ld   a,(CLEN)
        inc  a               ;A =(CLEN)+1 (1-16) = decoded length
        ld   e,a
        call ADDINT
        cp   3
        jr   c,L3PLUS        ;decoded length 1or2, encoded length 1or2 (+0,1or2 bits)
        ld   a,3             ;decoded length 3+,encoded length 3 (+1 bit)

L3PLUS: call STAKA           ;stack len
        ld   a,(XBIT)
        call STAKA
        ld   a,8
        call STAKA
        rst  $28             ;l(len,2),len,b,8
        defb $05  ;divide    ;l(len,2),len,b/8
        defb $0F  ;add       ;l(len,2),len+b/8
        defb $0F  ;add       ;l(len,2)+len+b/8
        defb $38  ;end_calc  ;l(len,2) updated

GOTO80: call FETCHS
        pop  hl           ;1<;HL=l(len,2) address
        call LDLEN2

        pop  af
        pop  bc
        pop  de
        ret

        ;copy an l() value
LDAEDCB:ld   a,(hl)
        inc  hl
        ld   e,(hl)
        inc  hl
        ld   d,(hl)
        inc  hl
        ld   c,(hl)
        inc  hl
        ld   b,(hl)
        inc  hl
        ret

        ;update an l(len,1) or l(len,3) INT value
ADDINT: ld   b,c             ;stored as "00 00 dd cc 00"
        ld   c,d             ;BC=old array smallint
        push hl
        ld   h,0
        ld   l,e             ;E =value to add on
        add  hl,bc
        ex   de,hl           ;DE=new array smallint
        pop  hl              ;HL=next element address
        push hl
        dec  hl
        dec  hl
        ld   (hl),d
        dec  hl
        ld   (hl),e
        pop  hl              ;HL=next element address
        ret

        ;update an l(len,2) value
LDLEN2: ld   (hl),a
        inc  hl
        ld   (hl),e
        inc  hl
        ld   (hl),d
        inc  hl
        ld   (hl),c
        inc  hl
        ld   (hl),b
        inc  hl
        ret


;===================

LABELS: defw OUTPUT, SETUPE, ENLOOP, MALOOP, LONGEST, SETUPD
        defw STATS
PROGEND:defb $FF